---
title: Create a test suite
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Synthetics
---

# Create a test suite{% #create-a-test-suite %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                |
| ----------------- | ----------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/synthetics/suites |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/synthetics/suites |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/synthetics/suites      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/synthetics/suites      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/synthetics/suites  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/synthetics/suites     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/synthetics/suites |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/synthetics/suites |

### Overview

This endpoint requires any of the following permissions:
`synthetics_write``synthetics_create_edit_trigger` 


OAuth apps require the `synthetics_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#synthetics) to access this endpoint.



### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                        | Type     | Description                                                                       |
| ------------ | ---------------------------- | -------- | --------------------------------------------------------------------------------- |
|              | data [*required*]       | object   | Data object for creating or editing a Synthetic test suite.                       |
| data         | attributes [*required*] | object   | Object containing details about a Synthetic suite.                                |
| attributes   | message                      | string   | Notification message associated with the suite.                                   |
| attributes   | monitor_id                   | int64    | The associated monitor ID.                                                        |
| attributes   | name [*required*]       | string   | Name of the suite.                                                                |
| attributes   | options [*required*]    | object   | Object describing the extra options for a Synthetic suite.                        |
| options      | alerting_threshold           | double   | Percentage of critical tests failure needed for a suite to fail.                  |
| attributes   | public_id                    | string   | The public ID for the test.                                                       |
| attributes   | tags                         | [string] | Array of tags attached to the suite.                                              |
| attributes   | tests [*required*]      | [object] | Array of Synthetic tests included in the suite.                                   |
| tests        | alerting_criticality         | enum     | Alerting criticality for each the test. Allowed enum values: `ignore,critical`    |
| tests        | public_id [*required*]  | string   | The public ID of the Synthetic test included in the suite.                        |
| attributes   | type [*required*]       | enum     | Type of the Synthetic suite, `suite`. Allowed enum values: `suite`                |
| data         | type [*required*]       | enum     | Type for the Synthetics suites responses, `suites`. Allowed enum values: `suites` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "message": "Notification message",
      "name": "Example suite name",
      "options": {},
      "tags": [
        "env:production"
      ],
      "tests": [],
      "type": "suite"
    },
    "type": "suites"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Synthetics suite response

| Parent field | Field                       | Type     | Description                                                                       |
| ------------ | --------------------------- | -------- | --------------------------------------------------------------------------------- |
|              | data                        | object   | Synthetics suite response data                                                    |
| data         | attributes                  | object   | Object containing details about a Synthetic suite.                                |
| attributes   | message                     | string   | Notification message associated with the suite.                                   |
| attributes   | monitor_id                  | int64    | The associated monitor ID.                                                        |
| attributes   | name [*required*]      | string   | Name of the suite.                                                                |
| attributes   | options [*required*]   | object   | Object describing the extra options for a Synthetic suite.                        |
| options      | alerting_threshold          | double   | Percentage of critical tests failure needed for a suite to fail.                  |
| attributes   | public_id                   | string   | The public ID for the test.                                                       |
| attributes   | tags                        | [string] | Array of tags attached to the suite.                                              |
| attributes   | tests [*required*]     | [object] | Array of Synthetic tests included in the suite.                                   |
| tests        | alerting_criticality        | enum     | Alerting criticality for each the test. Allowed enum values: `ignore,critical`    |
| tests        | public_id [*required*] | string   | The public ID of the Synthetic test included in the suite.                        |
| attributes   | type [*required*]      | enum     | Type of the Synthetic suite, `suite`. Allowed enum values: `suite`                |
| data         | id                          | string   | The public ID for the suite.                                                      |
| data         | type                        | enum     | Type for the Synthetics suites responses, `suites`. Allowed enum values: `suites` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "message": "Notification message",
      "monitor_id": 12345678,
      "name": "Example suite name",
      "options": {
        "alerting_threshold": "number"
      },
      "public_id": "123-abc-456",
      "tags": [
        "env:production"
      ],
      "tests": [
        {
          "alerting_criticality": "critical",
          "public_id": ""
        }
      ],
      "type": "suite"
    },
    "id": "123-abc-456",
    "type": "suites"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
API error response.
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/synthetics/suites" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "message": "Notification message",
      "monitor_id": 12345678,
      "name": "Example suite name",
      "public_id": "123-abc-456",
      "tags": [
        "env:production"
      ],
      "tests": [
        {
          "alerting_criticality": "critical",
          "public_id": ""
        }
      ],
      "type": "suite"
    },
    "type": "suites"
  }
}
EOF 
                        
##### 

```go
// Create a test suite returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.SuiteCreateEditRequest{
		Data: datadogV2.SuiteCreateEdit{
			Attributes: datadogV2.SyntheticsSuite{
				Message: datadog.PtrString("Notification message"),
				Name:    "Example suite name",
				Options: datadogV2.SyntheticsSuiteOptions{},
				Tags: []string{
					"env:production",
				},
				Tests: []datadogV2.SyntheticsSuiteTest{},
				Type:  datadogV2.SYNTHETICSSUITETYPE_SUITE,
			},
			Type: datadogV2.SYNTHETICSSUITETYPES_SUITES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSyntheticsApi(apiClient)
	resp, r, err := api.CreateSyntheticsSuite(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SyntheticsApi.CreateSyntheticsSuite`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SyntheticsApi.CreateSyntheticsSuite`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create a test suite returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SyntheticsApi;
import com.datadog.api.client.v2.model.SuiteCreateEdit;
import com.datadog.api.client.v2.model.SuiteCreateEditRequest;
import com.datadog.api.client.v2.model.SyntheticsSuite;
import com.datadog.api.client.v2.model.SyntheticsSuiteOptions;
import com.datadog.api.client.v2.model.SyntheticsSuiteResponse;
import com.datadog.api.client.v2.model.SyntheticsSuiteType;
import com.datadog.api.client.v2.model.SyntheticsSuiteTypes;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    SyntheticsApi apiInstance = new SyntheticsApi(defaultClient);

    SuiteCreateEditRequest body =
        new SuiteCreateEditRequest()
            .data(
                new SuiteCreateEdit()
                    .attributes(
                        new SyntheticsSuite()
                            .message("Notification message")
                            .name("Example suite name")
                            .options(new SyntheticsSuiteOptions())
                            .tags(Collections.singletonList("env:production"))
                            .type(SyntheticsSuiteType.SUITE))
                    .type(SyntheticsSuiteTypes.SUITES));

    try {
      SyntheticsSuiteResponse result = apiInstance.createSyntheticsSuite(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SyntheticsApi#createSyntheticsSuite");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Create a test suite returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.synthetics_api import SyntheticsApi
from datadog_api_client.v2.model.suite_create_edit import SuiteCreateEdit
from datadog_api_client.v2.model.suite_create_edit_request import SuiteCreateEditRequest
from datadog_api_client.v2.model.synthetics_suite import SyntheticsSuite
from datadog_api_client.v2.model.synthetics_suite_options import SyntheticsSuiteOptions
from datadog_api_client.v2.model.synthetics_suite_type import SyntheticsSuiteType
from datadog_api_client.v2.model.synthetics_suite_types import SyntheticsSuiteTypes

body = SuiteCreateEditRequest(
    data=SuiteCreateEdit(
        attributes=SyntheticsSuite(
            message="Notification message",
            name="Example suite name",
            options=SyntheticsSuiteOptions(),
            tags=[
                "env:production",
            ],
            tests=[],
            type=SyntheticsSuiteType.SUITE,
        ),
        type=SyntheticsSuiteTypes.SUITES,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = SyntheticsApi(api_client)
    response = api_instance.create_synthetics_suite(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create a test suite returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::SyntheticsAPI.new

body = DatadogAPIClient::V2::SuiteCreateEditRequest.new({
  data: DatadogAPIClient::V2::SuiteCreateEdit.new({
    attributes: DatadogAPIClient::V2::SyntheticsSuite.new({
      message: "Notification message",
      name: "Example suite name",
      options: DatadogAPIClient::V2::SyntheticsSuiteOptions.new({}),
      tags: [
        "env:production",
      ],
      tests: [],
      type: DatadogAPIClient::V2::SyntheticsSuiteType::SUITE,
    }),
    type: DatadogAPIClient::V2::SyntheticsSuiteTypes::SUITES,
  }),
})
p api_instance.create_synthetics_suite(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Create a test suite returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_synthetics::SyntheticsAPI;
use datadog_api_client::datadogV2::model::SuiteCreateEdit;
use datadog_api_client::datadogV2::model::SuiteCreateEditRequest;
use datadog_api_client::datadogV2::model::SyntheticsSuite;
use datadog_api_client::datadogV2::model::SyntheticsSuiteOptions;
use datadog_api_client::datadogV2::model::SyntheticsSuiteType;
use datadog_api_client::datadogV2::model::SyntheticsSuiteTypes;

#[tokio::main]
async fn main() {
    let body = SuiteCreateEditRequest::new(SuiteCreateEdit::new(
        SyntheticsSuite::new(
            "Example suite name".to_string(),
            SyntheticsSuiteOptions::new(),
            vec![],
            SyntheticsSuiteType::SUITE,
        )
        .message("Notification message".to_string())
        .tags(vec!["env:production".to_string()]),
        SyntheticsSuiteTypes::SUITES,
    ));
    let configuration = datadog::Configuration::new();
    let api = SyntheticsAPI::with_config(configuration);
    let resp = api.create_synthetics_suite(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create a test suite returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.SyntheticsApi(configuration);

const params: v2.SyntheticsApiCreateSyntheticsSuiteRequest = {
  body: {
    data: {
      attributes: {
        message: "Notification message",
        name: "Example suite name",
        options: {},
        tags: ["env:production"],
        tests: [],
        type: "suite",
      },
      type: "suites",
    },
  },
};

apiInstance
  .createSyntheticsSuite(params)
  .then((data: v2.SyntheticsSuiteResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
